



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>apache高负载性能调优</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">apache高负载性能调优</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 17:47:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>先阅读apache配置优化建议如下，再对相关参数进行调整，观察服务器状况.<br />Apache配置优化建议:<br />进入/usr/local/apache2/conf/extra 目录下<br />Apache优化,<br />经过上述操作后，Apache已经能够正常运行。但是，对于访问量稍大的站点，Apache的这些默认配置是无法满足需求的，我们仍需调整Apache的一些参数，使Apache能够在大访问量环境下发挥出更好的性能。以下我们对Apache配置文件httpd.conf中对性能影响较大的参数进行一些说明。</p>
<p>(1) Timeout 该参数指定Apache在接收请求或发送所请求内容之前的最长等待时间（秒），若超过该时间Apache则放弃处理该请求，并释放连接。该参数默认值为120，推荐设置为60，对于访问量较大的网站可以设置为30或15。</p>
<p>(2) KeepAlive 该参数控制Apache是否允许在一个连接中有多个请求，默认打开。但对于大多数论坛类型站点来说，通常设置为off以关闭该支持。</p>
<p>(3) MPM - prefork.c 在默认情况下Apache使用Prefork（进程）工作模式，可以说这部分的参数设置是对Apache性能影响的核心和关键。用户可以在配置文档中找到以下配置段：</p>
<div>
<div>&nbsp; &nbsp;&lt;IfModule prefork.c&gt;</p>
<ul><li>StartServers&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;5</li>
<li>MinSpareServers&nbsp; &nbsp;&nbsp; &nbsp;5</li>
<li>MaxSpareServers&nbsp; &nbsp;&nbsp;&nbsp;10</li>
<li>MaxClients&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp; 15</li>
<li>MaxRequestsPerChild&nbsp;&nbsp;0</li>
<li>&lt;/IfModule&gt;</li></ul>
</div>
<p>复制代码</p></div>
<p>这就是控制Apache进程工作的配置段，为了更好的理解上述配置中的各项参数，下面让我们先了解一下Apache是如何控制进程工作的。我们知道，在Unix系统中，很多服务(Service)的守护进程(Daemon)在启动时会创建一个进程以准备应答可能的连接请求，服务即进入了端口监听状态，当一个来自客户端(Client)的请求被发送至服务所监听的端口时，该服务进程即会处理该请求，在处理过程中，该进程处于独占状态，也就是说如果此时有其他请求到达，这些请求只能&ldquo;排队&rdquo;等待当前请求处理完成且服务进程释放。这样就会导致越来越多的请求处于队列等待状态，实际表现就是该服务处理能力非常低下。Apache使用Prefork模式很好的解决了这一问题。下面我们来看看Apache实际上是如何高效率工作的。</p>
<p>当Apache启动时，Apache会启动StartSpareServers个空闲进程同时准备接收处理请求，当多个请求到来时，StarSpareServers进行会越来越少，当空闲进程减少到MinSpareServers个时，Apache为了能够继续有充裕的进程处理请求，它会再启动StartsServers个进程备用，这样就大大减少了请求队列等待的可能，使得服务效率提高，这也是为什么叫做Pre-fork的原因；让我们继续跟踪Apache的工作，我们假设Apache已经启动了200个进程来处理请求，理论上来说，此时Apache一共有205个进程，而过了一段时间，假设有100个请求都得到了Apache的响应和处理，那么此时这100个进程就被释放成为空闲进程，那么此时Apache有105个空闲进程。而对于服务而言，启动太多的空闲进程时没有任何意义的，反而会降低服务器的整体性能，那么Apache真的会有105个空闲进程么？当然不会！实际上Apache随时在检查自己，当发现有超过MaxSpareServers个空闲进程时，则会自动停止关闭一些进程，以保证空闲进程不过过多。说到这里，用户应该对Apache的工作方式有了一定的了解，如果想获得更多更详细的说明请参阅Apache手册文档。</p>
<p>我们还有两个参数没有介绍：MaxClients和MaxRequestPerchild；MaxClients指定Apache在同一时间内最多允许有多少客户端能够与其连接，如果超过MaxClients个连接，客户端将会得到一个&ldquo;服务器繁忙&rdquo;的错误页面。我们看到默认情况下MaxClients设置为15，这对一些中型站点和大型站点显然是远远不够的！也许您需要同时允许512个客户端连接才能满足应用需求，好吧，那么就让我们把MaxClients修改为512，保存httpd.conf并退出，重启Apache，很遗憾，在重启过程当中您看到了一些错误提示，Apache重启失败。错误提示中告诉您MaxClients最大只能设定为256，相信您一定很失望。不过不要沮丧，Apache作为世界一流的Web Server一定不会如此单薄的！在默认情况下，MaxClients的确只能设定为不超过256的整数，但是，如果您有需要完全可以随意定制，此时就需要使用ServerLimit参数来配合使用，简单的说ServerLimit就像是水桶，而MaxClients就像是水，您可以通过更换更大的水桶（将ServerLimit设定为一个较大值）来容纳更多的水(MaxClients)，但要注意，MaxClients的设定数值是不能大于ServerLimit的设定数值的！</p>
<p>注:MaxClents &lt; ServerLimit</p>
<p>下面让我们了解一下MaxRequestPerChild参数，该参数指定一个连接进程中可以有多少个线程同时工作。也许这样解释过于专业，那么您只要想想&ldquo;网络蚂蚁&rdquo;、&ldquo;网际快车FlashGet&rdquo;中的&ldquo;多点同时下载&rdquo;即可，该参数实际上就是限制最多可以用几个&ldquo;点&rdquo;。默认设置为0，即为：不限制。但需要注意，如果将该值设置的过小会引起访问问题，如果没有特殊需要或者访问量压力并非很大可以保持默认值，如果访问量很大则推荐设置为2048。</p>
<p>好了，解释了这么多，让我们看看经过修改后Perfork.c配置段的推荐配置：</p>
<div>
<div>&nbsp; &nbsp;&lt;IfModule prefork.c&gt;</p>
<ul><li>StartServers&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;5</li>
<li>MinSpareServers&nbsp; &nbsp;&nbsp; &nbsp;5</li>
<li>MaxSpareServers&nbsp; &nbsp;&nbsp;&nbsp;10</li>
<li>ServerLimit&nbsp; &nbsp;&nbsp; &nbsp; 1024</li>
<li>MaxClients&nbsp; &nbsp;&nbsp; &nbsp;&nbsp;&nbsp;768</li>
<li>MaxRequestsPerChild&nbsp;&nbsp;0</li>
<li>&lt;/IfModule&gt;</li></ul>
</div>
<p>复制代码</p></div>
<p>完成了上述对Apache的调整，Apache已经获得了较大的性能改善。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q25ky3q.html">【腾讯Bugly干货分享】让 CodeReview 这股清流再飞一会儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv2rjz9.html">前段播放 流媒体&lpar;RTMP&comma;RTSP&comma;HLS&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93wlw0q.html">Ubuntu杂记&mdash;&mdash;双系统重装Win7后找不到Ubuntu的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7d4gxq.html">关于for循环删除数组内容出现的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvymzzq.html">C&num; 基础（5）--字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gnw7e8.html">Android百度地图开发（一）之初体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v46r9.html">XCODE 出现 The operation couldn&amp;&num;39&semi;t be completed&period;&lpar;LaunchServicesError error 0&period;&rpar;错误修复</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn105n28.html">VS2012、VS2010、VS2008常用的快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj663z9.html">数据库（学习整理）----4--Oracle数据查询（基础点1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvv659.html">Could not locate executable E&colon;&bsol;SoftWave&bsol;Hadoop-2&period;2&period;0&bsol;bin&bsol;winutils&period;exe in the Hadoop binaries解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96plopj8.html">Vim入门学习之Vim解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg33ld8.html">hdu2262  Where is the canteen</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me0n2rq.html">Web前端2019面试总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1d60q.html">Http协议入门、响应与请求行、HttpServletRequest对象的使用、请求参数获取和编码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrkgn9.html">Google SwipeRefreshLayout（Goolge官方下拉刷新控件）尝鲜</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljg7069.html">jq筛选方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv1ynk8.html">联想Y410P在Ubuntu系统下开关机及插耳机破音&OpenCurlyDoubleQuote;啪啪&rdquo;的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e44n0z9.html">HttpClient之可恨的Expect（C&num; http 请求卡住的解决办法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj5lm09.html">删除maven仓库中的LastUpdated文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25y35wq.html">centos6 下erlang安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8moy329.html">Delphi XE5 与其他版本共存</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnrg729.html">TWICImage&period;SaveToStream内存泄漏的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd6r208.html">c signal</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ox2358.html">Qt 之 使用 https发送 HTTP请求（使用OPENSSL库）</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw7xvy8.html">node&period;js事件触发</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnr0dg9.html">设计模式：中介者模式（Mediator）</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw7ew38.html">关于TCP传输速率的测量方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q27eox8.html">Sql server中左连接语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/390w37nq.html">ELK-Python（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1g3n4q.html">互联网4&period;0时代需要商业智能BI</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
